﻿-- Author      : jjacob
-- Create Date : 10/19/2008 5:28:33 PM

function XP_timer_OnLoad()
	this:RegisterEvent("PLAYER_XP_UPDATE");
	this:RegisterEvent("PLAYER_LOGIN");
	SLASH_XPTIMERRESET1 = "/xp_timer_reset"
	SlashCmdList["XPTIMERRESET"] = XP_timer_reset;
	SLASH_XPTIMER1 = "/xpt"
	SLASH_XPTIMER2 = "/xp_timer"
	SlashCmdList["XPTIMER"] = XP_timer_display;
end

function XP_timer_OnEvent()
	if (event == "PLAYER_LOGIN") then
		XP_timer_reset();
	end 
	if (event == "PLAYER_XP_UPDATE") then
		local xp_timer_xp_cur = UnitXP("player");
		local xp_timer_xp_diff_old = xp_timer_xp_diff;
		xp_timer_xp_diff = xp_timer_xp_cur - xp_timer_old_xp;
		if (xp_timer_xp_diff < 0) then -- lvled up
			xp_timer_xp_diff = xp_timer_xp_diff_old; -- assume that the expgained was the same as before, this will quickly factor out over time.
		end
		--track total xp gained
		xp_timer_xp_gained = xp_timer_xp_gained + xp_timer_xp_diff;
		-- find amount of time playing
		local xp_timer_time_diff = GetTime() - xp_timer_start_time;
		if (xp_timer_time_diff > 0) then -- incase xp is gained instantly upon login
			local xp_timer_xp_per_second = xp_timer_xp_gained / xp_timer_time_diff;
			DEFAULT_CHAT_FRAME:AddMessage("Time to next level: "..to_hms_string((UnitXPMax("player") - xp_timer_xp_cur) / xp_timer_xp_per_second));
			xp_timer_old_xp = xp_timer_xp_cur;
		end -- time has passed:
	end -- end Player XP update
end

function XP_timer_reset()
	DEFAULT_CHAT_FRAME:AddMessage("XP Timer reset2");
	xp_timer_old_xp = UnitXP("player");
	xp_timer_start_time = GetTime(); 
	xp_timer_xp_gained = 1;
	xp_timer_xp_diff = 1;
end

function XP_timer_display()
	local xp_timer_time_diff = GetTime() - xp_timer_start_time;
	DEFAULT_CHAT_FRAME:AddMessage("Time Logged IN: "..to_hms_string(xp_timer_time_diff));
	DEFAULT_CHAT_FRAME:AddMessage("XP Gained total: "..xp_timer_xp_gained);
	DEFAULT_CHAT_FRAME:AddMessage("XP Gained: "..xp_timer_xp_diff);
	local xp_timer_xp_per_second = xp_timer_xp_gained / xp_timer_time_diff;
	DEFAULT_CHAT_FRAME:AddMessage("XP per second: "..xp_timer_xp_per_second);
	local xp_timer_xp_cur = UnitXP("player");
	local xp_timer_kills_to_lvl = math.ceil((UnitXPMax("player") - xp_timer_xp_cur) / xp_timer_xp_diff);
	DEFAULT_CHAT_FRAME:AddMessage("Kills to next level: "..xp_timer_kills_to_lvl);
	DEFAULT_CHAT_FRAME:AddMessage("Time to next level: "..to_hms_string((UnitXPMax("player") - xp_timer_xp_cur) / xp_timer_xp_per_second));
end

function to_hms(seconds)
  hours = math.floor (seconds / 3600);
  seconds = seconds - (hours * 3600);
  minutes = math.floor (seconds / 60);
  seconds = math.floor (seconds - (minutes * 60));
  return hours,minutes,seconds;
end --to_hms

function to_hms_string(seconds)
  return string.format("%d:%.2d:%.2d", to_hms(seconds));
end --to_hms_string